diff --git a/src/main/java/net/minecraft/server/MinecraftServer.java b/src/main/java/net/minecraft/server/MinecraftServer.java
index a6511c78c..359137987 100644
--- a/src/main/java/net/minecraft/server/MinecraftServer.java
+++ b/src/main/java/net/minecraft/server/MinecraftServer.java
@@ -1,5 +1,6 @@
 package net.minecraft.server;
 
+import com.mojang.brigadier.exceptions.CommandSyntaxException;
 import com.mojang.logging.LogUtils;
 import com.mojang.nbt.CompoundTag;
 import net.minecraft.core.Global;
@@ -17,7 +18,8 @@ import net.minecraft.core.net.IUpdatePlayerListBox;
 import net.minecraft.core.net.NetworkManager;
 import net.minecraft.core.net.PropertyManager;
 import net.minecraft.core.net.ServerCommandEntry;
-import net.minecraft.core.net.command.ServerCommandHandler;
+import net.minecraft.core.net.command.util.CommandHelper;
+import net.minecraft.server.net.command.ConsoleCommandSource;
 import net.minecraft.core.net.packet.SetTimePacket;
 import net.minecraft.core.player.gamemode.Gamemode;
 import net.minecraft.core.sound.SoundTypes;
@@ -46,7 +48,6 @@ import net.minecraft.server.entity.EntityTracker;
 import net.minecraft.server.entity.ServerSkinVariantList;
 import net.minecraft.server.entity.player.ServerPlayer;
 import net.minecraft.server.gui.ServerGui;
-import net.minecraft.server.net.ConsoleCommandHandler;
 import net.minecraft.server.net.NetworkListenThread;
 import net.minecraft.server.net.PlayerList;
 import net.minecraft.server.world.ConvertProgressUpdater;
@@ -82,7 +83,6 @@ public class MinecraftServer
     public PropertyManager propertyManager;
     public WorldServer[] dimensionWorlds;
     public PlayerList playerList;
-    private ConsoleCommandHandler commandHandler;
     private boolean serverRunning;
     public boolean serverStopped;
     int deathTime;
@@ -97,7 +97,6 @@ public class MinecraftServer
     public int spawnProtectionRange;
     public WorldType defaultWorldType;
     public int difficulty;
-    public final ServerCommandHandler serverCommandHandler = new ServerCommandHandler(this);
     public String joinMessage = null;
     public int summonLimit;
     public String language;
@@ -143,7 +142,6 @@ public class MinecraftServer
     {
         instance = this;
         isServer = true;
-        commandHandler = new ConsoleCommandHandler(this);
         Thread commandReadingThreads = new Thread(() -> {
             BufferedReader bufferedreader = new BufferedReader(new InputStreamReader(System.in));
             String s = null;
@@ -168,8 +166,8 @@ public class MinecraftServer
         // Manually initialize blocks and items
         Blocks.init();
         Items.init();
-
         Dimension.init();
+        CommandHelper.init();
 
         LOGGER.info("Loading properties");
         propertyManager = new PropertyManager(new File("server.properties"));
@@ -683,10 +681,16 @@ public class MinecraftServer
 
     public void commandLineParser()
     {
-        ServerCommandEntry servercommand;
-        for (; commands.size() > 0; commandHandler.handleCommand(servercommand))
+        while (!commands.isEmpty())
         {
-            servercommand = commands.remove(0);
+            ServerCommandEntry serverCommand = commands.remove(0);
+            String command = serverCommand.command;
+            ConsoleCommandSource source = new ConsoleCommandSource(this);
+            try {
+                getDimensionWorld(0).getCommandManager().execute(command, source);
+            } catch (CommandSyntaxException e) {
+                source.sendMessage(e.getMessage());
+            }
         }
 
     }
diff --git a/src/main/java/net/minecraft/server/net/command/ConsoleCommandSource.java b/src/main/java/net/minecraft/server/net/command/ConsoleCommandSource.java
new file mode 100644
index 000000000..399b3dc81
--- /dev/null
+++ b/src/main/java/net/minecraft/server/net/command/ConsoleCommandSource.java
@@ -0,0 +1,114 @@
+package net.minecraft.server.net.command;
+
+import com.mojang.logging.LogUtils;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.net.command.CommandSource;
+import net.minecraft.core.net.packet.ChatPacket;
+import net.minecraft.core.util.helper.AES;
+import net.minecraft.core.util.helper.LoggedPrintStream;
+import net.minecraft.core.util.phys.Vec3;
+import net.minecraft.core.world.World;
+import net.minecraft.server.MinecraftServer;
+import net.minecraft.server.entity.player.ServerPlayer;
+import org.jetbrains.annotations.Nullable;
+import org.slf4j.Logger;
+
+import java.util.ArrayList;
+import java.util.Collection;
+import java.util.List;
+
+public class ConsoleCommandSource implements CommandSource, IServerCommandSource {
+    private static final Logger LOGGER = LogUtils.getLogger();
+
+    public final MinecraftServer server;
+
+    public ConsoleCommandSource(MinecraftServer server) {
+        this.server = server;
+    }
+
+    @Override
+    public Collection<String> getPlayerNames() {
+        List<String> list = new ArrayList<>();
+        for (Player player : server.playerList.playerEntities) {
+            list.add(player.username);
+        }
+        return list;
+    }
+
+    @Override
+    public Collection<String> getEntitySuggestions() {
+        return this.getPlayerNames();
+    }
+
+    @Override
+    public String toString() {
+        return "ConsoleCommandSource{" + this.server + "}";
+    }
+
+    @Override
+    public Player getSender() {
+        return null;
+    }
+
+    @Override
+    public boolean hasAdmin() {
+        return true;
+    }
+
+    @Override
+    public @Nullable Vec3 getCoordinates(boolean offsetHeight) {
+        return null;
+    }
+
+    @Override
+    public @Nullable Vec3 getBlockCoordinates() {
+        return null;
+    }
+
+    @Override
+    public boolean messageMayBeMultiline() {
+        return true;
+    }
+
+    @Override
+    public void sendMessage(String message) {
+        LOGGER.info(LoggedPrintStream.removeColorCodes(message));
+    }
+
+    @Override
+    public void sendMessage(Player player, String message) {
+        this.server.playerList.sendPacketToPlayer(player.username, new ChatPacket(message, AES.keyChain.get(player.username)));
+    }
+
+    @Override
+    public void sendMessageToAllPlayers(String message) {
+        this.getServer().playerList.sendPacketToAllPlayers(new ChatPacket(message));
+    }
+
+    @Override
+    public World getWorld() {
+        return this.server.getDimensionWorld(0);
+    }
+
+    @Override
+    public World getWorld(int dimension) {
+        return this.server.getDimensionWorld(dimension);
+    }
+
+    @Override
+    public void movePlayerToDimension(Player player, int dimension) {
+        if (player instanceof ServerPlayer)
+            this.server.playerList.sendPlayerToOtherDimension((ServerPlayer) player, dimension, false);
+        else throw new IllegalStateException("Player is not an instance of ServerPlayer");
+    }
+
+    @Override
+    public String getName() {
+        return "Server";
+    }
+
+    @Override
+    public MinecraftServer getServer() {
+        return this.server;
+    }
+}
\ No newline at end of file
diff --git a/src/main/java/net/minecraft/server/net/command/IServerCommandSource.java b/src/main/java/net/minecraft/server/net/command/IServerCommandSource.java
new file mode 100644
index 000000000..4ce157913
--- /dev/null
+++ b/src/main/java/net/minecraft/server/net/command/IServerCommandSource.java
@@ -0,0 +1,7 @@
+package net.minecraft.server.net.command;
+
+import net.minecraft.server.MinecraftServer;
+
+public interface IServerCommandSource {
+    MinecraftServer getServer();
+}
diff --git a/src/main/java/net/minecraft/server/net/command/ServerCommandSource.java b/src/main/java/net/minecraft/server/net/command/ServerCommandSource.java
new file mode 100644
index 000000000..ec5e577ff
--- /dev/null
+++ b/src/main/java/net/minecraft/server/net/command/ServerCommandSource.java
@@ -0,0 +1,115 @@
+package net.minecraft.server.net.command;
+
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.net.command.CommandSource;
+import net.minecraft.core.net.packet.ChatPacket;
+import net.minecraft.core.util.helper.AES;
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.util.phys.Vec3;
+import net.minecraft.core.world.World;
+import net.minecraft.server.MinecraftServer;
+import net.minecraft.server.entity.player.ServerPlayer;
+import org.jetbrains.annotations.NotNull;
+
+import java.util.ArrayList;
+import java.util.Collection;
+import java.util.List;
+
+public class ServerCommandSource implements CommandSource, IServerCommandSource {
+    public final MinecraftServer server;
+    public final ServerPlayer player;
+
+    public ServerCommandSource(MinecraftServer server, ServerPlayer player) {
+        this.server = server;
+        this.player = player;
+    }
+
+    @Override
+    public Collection<String> getPlayerNames() {
+        List<String> list = new ArrayList<>();
+        for (Player player : server.playerList.playerEntities) {
+            list.add(player.username);
+        }
+        return list;
+    }
+
+    @Override
+    public Collection<String> getEntitySuggestions() {
+        return this.getPlayerNames();
+    }
+
+    @Override
+    public String toString() {
+        return "ServerCommandSource{" + this.server + ", " + this.player + "}";
+    }
+
+    @Override
+    public @NotNull Player getSender() {
+        return this.player;
+    }
+
+    @Override
+    public boolean hasAdmin() {
+        return this.server.playerList.isOp(this.getSender().uuid);
+    }
+
+    @Override
+    public @NotNull Vec3 getCoordinates(boolean offsetHeight) {
+        Vec3 position = this.getSender().getPosition(1.0f);
+        if (offsetHeight) return position.add(0.0f, -this.getSender().heightOffset, 0.0f);
+        return position;
+    }
+
+    @Override
+    public @NotNull Vec3 getBlockCoordinates() {
+        Vec3 coordinates = this.getCoordinates(true);
+        return Vec3.getTempVec3(MathHelper.floor(coordinates.x), MathHelper.floor(coordinates.y), MathHelper.floor(coordinates.z));
+    }
+
+    @Override
+    public boolean messageMayBeMultiline() {
+        return !this.getSender().username.equals("pr_ib");
+    }
+
+    @Override
+    public void sendMessage(String message) {
+        this.player.playerNetServerHandler.sendPacket(new ChatPacket(message, AES.keyChain.get(this.player.username)));
+    }
+
+    @Override
+    public void sendMessage(Player player, String message) {
+        this.server.playerList.sendPacketToPlayer(player.username, new ChatPacket(message, AES.keyChain.get(player.username)));
+    }
+
+    @Override
+    public void sendMessageToAllPlayers(String message) {
+        this.getServer().playerList.sendPacketToAllPlayers(new ChatPacket(message));
+    }
+
+    @Override
+    public World getWorld() {
+        return this.player == null ? this.server.getDimensionWorld(0) : this.player.world;
+    }
+
+    @Override
+    public World getWorld(int dimension) {
+        return this.server.getDimensionWorld(dimension);
+    }
+
+    @Override
+    public void movePlayerToDimension(Player player, int dimension) {
+        if (player instanceof ServerPlayer)
+            this.server.playerList.sendPlayerToOtherDimension((ServerPlayer) player, dimension, false);
+        else throw new IllegalStateException("Player is not an instance of ServerPlayer");
+    }
+
+    @Override
+    public String getName() {
+        return this.player.username;
+    }
+
+    @Override
+    public MinecraftServer getServer() {
+        return this.server;
+    }
+}
diff --git a/src/main/java/net/minecraft/server/net/command/commands/ColorCommand.java b/src/main/java/net/minecraft/server/net/command/commands/ColorCommand.java
new file mode 100644
index 000000000..b3b11947c
--- /dev/null
+++ b/src/main/java/net/minecraft/server/net/command/commands/ColorCommand.java
@@ -0,0 +1,313 @@
+package net.minecraft.server.net.command.commands;
+
+import com.mojang.brigadier.Command;
+import com.mojang.brigadier.CommandDispatcher;
+import com.mojang.brigadier.builder.LiteralArgumentBuilder;
+import com.mojang.brigadier.builder.RequiredArgumentBuilder;
+import com.mojang.brigadier.exceptions.CommandSyntaxException;
+import com.mojang.brigadier.tree.CommandNode;
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.lang.I18n;
+import net.minecraft.core.net.command.TextFormatting;
+import net.minecraft.core.net.command.CommandSource;
+import net.minecraft.server.net.command.IServerCommandSource;
+import net.minecraft.core.net.command.arguments.EntityArgumentType;
+import net.minecraft.core.net.command.exceptions.CommandExceptions;
+import net.minecraft.core.net.command.helpers.EntitySelector;
+import net.minecraft.core.net.command.util.CommandHelper;
+import net.minecraft.server.entity.player.ServerPlayer;
+
+import java.util.List;
+
+public class ColorCommand {
+    public static void register(CommandDispatcher<CommandSource> dispatcher) {
+        CommandNode<CommandSource> command = dispatcher.register(LiteralArgumentBuilder.<CommandSource>literal("color")
+            .then(LiteralArgumentBuilder.<CommandSource>literal("get")
+                .executes(c -> {
+                    CommandSource source = c.getSource();
+                    if (!(source instanceof IServerCommandSource))
+                        throw CommandExceptions.multiplayerWorldOnly().create();
+
+                    ServerPlayer player = (ServerPlayer) source.getSender();
+                    if (player == null) throw CommandExceptions.notInWorld().create();
+
+                    TextFormatting color = TextFormatting.get(player.chatColor);
+                    source.sendMessage(I18n.getInstance().translateKeyAndFormat("commands.commander.color.get.success", color + color.getNames()[0]));
+                    return Command.SINGLE_SUCCESS;
+                })
+                .then(RequiredArgumentBuilder.<CommandSource, EntitySelector>argument("target", EntityArgumentType.player())
+                    .executes(c -> {
+                        CommandSource source = c.getSource();
+                        if (!(source instanceof IServerCommandSource))
+                            throw CommandExceptions.multiplayerWorldOnly().create();
+
+                        EntitySelector entitySelector = c.getArgument("target", EntitySelector.class);
+                        ServerPlayer player = (ServerPlayer) entitySelector.get(source).get(0);
+
+                        TextFormatting color = TextFormatting.get(player.chatColor);
+                        source.sendMessage(I18n.getInstance().translateKeyAndFormat("commands.commander.color.get.success_other", color + color.getNames()[0]));
+                        return Command.SINGLE_SUCCESS;
+                    })))
+            .then(LiteralArgumentBuilder.<CommandSource>literal("set")
+                .then(LiteralArgumentBuilder.<CommandSource>literal("white")
+                    .executes(c -> {
+                        CommandSource source = c.getSource();
+                        return setColor((ServerPlayer) source.getSender(), source, (byte) 0);
+                    }))
+                .then(LiteralArgumentBuilder.<CommandSource>literal("orange")
+                    .executes(c -> {
+                        CommandSource source = c.getSource();
+                        return setColor((ServerPlayer) source.getSender(), source, (byte) 1);
+                    }))
+                .then(LiteralArgumentBuilder.<CommandSource>literal("magenta")
+                    .executes(c -> {
+                        CommandSource source = c.getSource();
+                        return setColor((ServerPlayer) source.getSender(), source, (byte) 2);
+                    }))
+                .then(LiteralArgumentBuilder.<CommandSource>literal("light_blue")
+                    .executes(c -> {
+                        CommandSource source = c.getSource();
+                        return setColor((ServerPlayer) source.getSender(), source, (byte) 3);
+                    }))
+                .then(LiteralArgumentBuilder.<CommandSource>literal("yellow")
+                    .executes(c -> {
+                        CommandSource source = c.getSource();
+                        return setColor((ServerPlayer) source.getSender(), source, (byte) 4);
+                    }))
+                .then(LiteralArgumentBuilder.<CommandSource>literal("lime")
+                    .executes(c -> {
+                        CommandSource source = c.getSource();
+                        return setColor((ServerPlayer) source.getSender(), source, (byte) 5);
+                    }))
+                .then(LiteralArgumentBuilder.<CommandSource>literal("pink")
+                    .executes(c -> {
+                        CommandSource source = c.getSource();
+                        return setColor((ServerPlayer) source.getSender(), source, (byte) 6);
+                    }))
+                .then(LiteralArgumentBuilder.<CommandSource>literal("gray")
+                    .executes(c -> {
+                        CommandSource source = c.getSource();
+                        return setColor((ServerPlayer) source.getSender(), source, (byte) 7);
+                    }))
+                .then(LiteralArgumentBuilder.<CommandSource>literal("light_gray")
+                    .executes(c -> {
+                        CommandSource source = c.getSource();
+                        return setColor((ServerPlayer) source.getSender(), source, (byte) 8);
+                    }))
+                .then(LiteralArgumentBuilder.<CommandSource>literal("cyan")
+                    .executes(c -> {
+                        CommandSource source = c.getSource();
+                        return setColor((ServerPlayer) source.getSender(), source, (byte) 9);
+                    }))
+                .then(LiteralArgumentBuilder.<CommandSource>literal("purple")
+                    .executes(c -> {
+                        CommandSource source = c.getSource();
+                        return setColor((ServerPlayer) source.getSender(), source, (byte) 10);
+                    }))
+                .then(LiteralArgumentBuilder.<CommandSource>literal("blue")
+                    .executes(c -> {
+                        CommandSource source = c.getSource();
+                        return setColor((ServerPlayer) source.getSender(), source, (byte) 11);
+                    }))
+                .then(LiteralArgumentBuilder.<CommandSource>literal("brown")
+                    .executes(c -> {
+                        CommandSource source = c.getSource();
+                        return setColor((ServerPlayer) source.getSender(), source, (byte) 12);
+                    }))
+                .then(LiteralArgumentBuilder.<CommandSource>literal("green")
+                    .executes(c -> {
+                        CommandSource source = c.getSource();
+                        return setColor((ServerPlayer) source.getSender(), source, (byte) 13);
+                    }))
+                .then(LiteralArgumentBuilder.<CommandSource>literal("red")
+                    .executes(c -> {
+                        CommandSource source = c.getSource();
+                        return setColor((ServerPlayer) source.getSender(), source, (byte) 14);
+                    }))
+                .then(LiteralArgumentBuilder.<CommandSource>literal("black")
+                    .executes(c -> {
+                        CommandSource source = c.getSource();
+                        return setColor((ServerPlayer) source.getSender(), source, (byte) 15);
+                    }))
+                .then(RequiredArgumentBuilder.<CommandSource, EntitySelector>argument("target", EntityArgumentType.players())
+                    .requires(CommandSource::hasAdmin)
+                    .then(LiteralArgumentBuilder.<CommandSource>literal("white")
+                        .executes(c -> {
+                            CommandSource source = c.getSource();
+                            EntitySelector entitySelector = c.getArgument("target", EntitySelector.class);
+                            List<? extends Entity> entities = entitySelector.get(source);
+                            for (Entity entity : entities) {
+                                setColor((ServerPlayer) entity, source, (byte) 0);
+                            }
+                            return Command.SINGLE_SUCCESS;
+                        }))
+                    .then(LiteralArgumentBuilder.<CommandSource>literal("orange")
+                        .executes(c -> {
+                            CommandSource source = c.getSource();
+                            EntitySelector entitySelector = c.getArgument("target", EntitySelector.class);
+                            List<? extends Entity> entities = entitySelector.get(source);
+                            for (Entity entity : entities) {
+                                setColor((ServerPlayer) entity, source, (byte) 1);
+                            }
+                            return Command.SINGLE_SUCCESS;
+                        }))
+                    .then(LiteralArgumentBuilder.<CommandSource>literal("magenta")
+                        .executes(c -> {
+                            CommandSource source = c.getSource();
+                            EntitySelector entitySelector = c.getArgument("target", EntitySelector.class);
+                            List<? extends Entity> entities = entitySelector.get(source);
+                            for (Entity entity : entities) {
+                                setColor((ServerPlayer) entity, source, (byte) 2);
+                            }
+                            return Command.SINGLE_SUCCESS;
+                        }))
+                    .then(LiteralArgumentBuilder.<CommandSource>literal("light_blue")
+                        .executes(c -> {
+                            CommandSource source = c.getSource();
+                            EntitySelector entitySelector = c.getArgument("target", EntitySelector.class);
+                            List<? extends Entity> entities = entitySelector.get(source);
+                            for (Entity entity : entities) {
+                                setColor((ServerPlayer) entity, source, (byte) 3);
+                            }
+                            return Command.SINGLE_SUCCESS;
+                        }))
+                    .then(LiteralArgumentBuilder.<CommandSource>literal("yellow")
+                        .executes(c -> {
+                            CommandSource source = c.getSource();
+                            EntitySelector entitySelector = c.getArgument("target", EntitySelector.class);
+                            List<? extends Entity> entities = entitySelector.get(source);
+                            for (Entity entity : entities) {
+                                setColor((ServerPlayer) entity, source, (byte) 4);
+                            }
+                            return Command.SINGLE_SUCCESS;
+                        }))
+                    .then(LiteralArgumentBuilder.<CommandSource>literal("lime")
+                        .executes(c -> {
+                            CommandSource source = c.getSource();
+                            EntitySelector entitySelector = c.getArgument("target", EntitySelector.class);
+                            List<? extends Entity> entities = entitySelector.get(source);
+                            for (Entity entity : entities) {
+                                setColor((ServerPlayer) entity, source, (byte) 5);
+                            }
+                            return Command.SINGLE_SUCCESS;
+                        }))
+                    .then(LiteralArgumentBuilder.<CommandSource>literal("pink")
+                        .executes(c -> {
+                            CommandSource source = c.getSource();
+                            EntitySelector entitySelector = c.getArgument("target", EntitySelector.class);
+                            List<? extends Entity> entities = entitySelector.get(source);
+                            for (Entity entity : entities) {
+                                setColor((ServerPlayer) entity, source, (byte) 6);
+                            }
+                            return Command.SINGLE_SUCCESS;
+                        }))
+                    .then(LiteralArgumentBuilder.<CommandSource>literal("gray")
+                        .executes(c -> {
+                            CommandSource source = c.getSource();
+                            EntitySelector entitySelector = c.getArgument("target", EntitySelector.class);
+                            List<? extends Entity> entities = entitySelector.get(source);
+                            for (Entity entity : entities) {
+                                setColor((ServerPlayer) entity, source, (byte) 7);
+                            }
+                            return Command.SINGLE_SUCCESS;
+                        }))
+                    .then(LiteralArgumentBuilder.<CommandSource>literal("light_gray")
+                        .executes(c -> {
+                            CommandSource source = c.getSource();
+                            EntitySelector entitySelector = c.getArgument("target", EntitySelector.class);
+                            List<? extends Entity> entities = entitySelector.get(source);
+                            for (Entity entity : entities) {
+                                setColor((ServerPlayer) entity, source, (byte) 8);
+                            }
+                            return Command.SINGLE_SUCCESS;
+                        }))
+                    .then(LiteralArgumentBuilder.<CommandSource>literal("cyan")
+                        .executes(c -> {
+                            CommandSource source = c.getSource();
+                            EntitySelector entitySelector = c.getArgument("target", EntitySelector.class);
+                            List<? extends Entity> entities = entitySelector.get(source);
+                            for (Entity entity : entities) {
+                                setColor((ServerPlayer) entity, source, (byte) 9);
+                            }
+                            return Command.SINGLE_SUCCESS;
+                        }))
+                    .then(LiteralArgumentBuilder.<CommandSource>literal("purple")
+                        .executes(c -> {
+                            CommandSource source = c.getSource();
+                            EntitySelector entitySelector = c.getArgument("target", EntitySelector.class);
+                            List<? extends Entity> entities = entitySelector.get(source);
+                            for (Entity entity : entities) {
+                                setColor((ServerPlayer) entity, source, (byte) 10);
+                            }
+                            return Command.SINGLE_SUCCESS;
+                        }))
+                    .then(LiteralArgumentBuilder.<CommandSource>literal("blue")
+                        .executes(c -> {
+                            CommandSource source = c.getSource();
+                            EntitySelector entitySelector = c.getArgument("target", EntitySelector.class);
+                            List<? extends Entity> entities = entitySelector.get(source);
+                            for (Entity entity : entities) {
+                                setColor((ServerPlayer) entity, source, (byte) 11);
+                            }
+                            return Command.SINGLE_SUCCESS;
+                        }))
+                    .then(LiteralArgumentBuilder.<CommandSource>literal("brown")
+                        .executes(c -> {
+                            CommandSource source = c.getSource();
+                            EntitySelector entitySelector = c.getArgument("target", EntitySelector.class);
+                            List<? extends Entity> entities = entitySelector.get(source);
+                            for (Entity entity : entities) {
+                                setColor((ServerPlayer) entity, source, (byte) 12);
+                            }
+                            return Command.SINGLE_SUCCESS;
+                        }))
+                    .then(LiteralArgumentBuilder.<CommandSource>literal("green")
+                        .executes(c -> {
+                            CommandSource source = c.getSource();
+                            EntitySelector entitySelector = c.getArgument("target", EntitySelector.class);
+                            List<? extends Entity> entities = entitySelector.get(source);
+                            for (Entity entity : entities) {
+                                setColor((ServerPlayer) entity, source, (byte) 13);
+                            }
+                            return Command.SINGLE_SUCCESS;
+                        }))
+                    .then(LiteralArgumentBuilder.<CommandSource>literal("red")
+                        .executes(c -> {
+                            CommandSource source = c.getSource();
+                            EntitySelector entitySelector = c.getArgument("target", EntitySelector.class);
+                            List<? extends Entity> entities = entitySelector.get(source);
+                            for (Entity entity : entities) {
+                                setColor((ServerPlayer) entity, source, (byte) 14);
+                            }
+                            return Command.SINGLE_SUCCESS;
+                        }))
+                    .then(LiteralArgumentBuilder.<CommandSource>literal("black")
+                        .executes(c -> {
+                            CommandSource source = c.getSource();
+                            EntitySelector entitySelector = c.getArgument("target", EntitySelector.class);
+                            List<? extends Entity> entities = entitySelector.get(source);
+                            for (Entity entity : entities) {
+                                setColor((ServerPlayer) entity, source, (byte) 15);
+                            }
+                            return Command.SINGLE_SUCCESS;
+                        })))));
+        dispatcher.register(LiteralArgumentBuilder.<CommandSource>literal("colour")
+            .redirect(command));
+    }
+
+    private static int setColor(ServerPlayer player, CommandSource source, byte colorId) throws CommandSyntaxException {
+        if (!(source instanceof IServerCommandSource)) throw CommandExceptions.multiplayerWorldOnly().create();
+
+        if (player == null) throw CommandExceptions.notInWorld().create();
+
+        player.chatColor = colorId;
+        TextFormatting color = TextFormatting.get(colorId);
+        if (player == source.getSender()) {
+            source.sendTranslatableMessage("commands.commander.color.set.success", color + color.getNames()[0]);
+        } else {
+            source.sendTranslatableMessage("commands.commander.color.set.success_other", CommandHelper.getEntityName(player), color + color.getNames()[0]);
+            source.sendTranslatableMessage(player, "commands.commander.color.set.success_receiver", color + color.getNames()[0]);
+        }
+        return Command.SINGLE_SUCCESS;
+    }
+}
